import base
import random
import copy



class Player(base.BasePlayer):
    
    def __init__(self, name, dictionary, board, bag, bigBagSize):
        base.BasePlayer.__init__(self, name, dictionary, board, bag, bigBagSize) #always keep this line and DON't change it
        self.text = "myGreatPlayer" #fill the name of your awesome player!

        #bellow you can define your own variables. Don't forget to use 'self.' to adress them correctly

    def move(self):
        """
            the main function of your player. This function is called by the gaming server to obtain
            your move. 
            Possible moves are:   
              return None     - this means to 'pass' (score/board/bag are not changed)
              return "hello"  - string of letters that you want to replace. Letters can repeat. 
                                Only letters in 'self.bag' can be used here. Not more than 7 letters.
              return [ [r1,c1,L1], [ r2,c2,L2]  ... [rn,cn,Ln] ], where 'r_x' is row, 'c_x' is columns and 'Lx' is the letter
                                that you want to place to the board.
                                You don't have to place these letters to self.board, it will be done anyway by Brute
        """
        return None;


def replaceLetters(player, lettersToReplace, bag):
    print("Player ", player.name, " want's to exchange ", len(lettersToReplace), ", bag has " , len(bag) , " letters");
        
    if (len(lettersToReplace) > 7 or len(lettersToReplace) > len(bag)):
        print("No replacement will be made, as the user either wants to replace >7 letters or more than than letters in the bag");
        return player.bag

    listLetters = list(lettersToReplace);
    newBag = []
    for letter in player.bag:
        if letter not in listLetters:
            newBag.append(letter)
        else:
            listLetters.remove(letter)
           
    new = "" 
    for i in range(len(lettersToReplace)):
        if len(bag) > 0:
            newBag.append(bag.pop())
            new += newBag[-1];
    print("New replacement ", new)
    return newBag



def afterMove(lastPlayer, lastPlayerResult, nextPlayer, board, bag):

    """
        simplifed game handling procedure. We assume here that both player behave correctly, e.g. they do not
        invalide their 'self.bag' etc..

        On Brute/Tournament, this function will also check all return types and validiy of actions
    """

    if (lastPlayerResult is None):
        #player 'pass', no change
        print("Player ", lastPlayer.name, " is passing ")
        return 0
    
    if isinstance(lastPlayerResult, str):
    
        newBag = replaceLetters(lastPlayer, lastPlayerResult, bag)    
        lastPlayer.update(board,newBag, lastPlayer.myScore, nextPlayer.myScore, len(bag))
        #the second player does not need to be updated, as the board didn't change
        return 0

    if isinstance(lastPlayerResult,list):
        #player is placing some letters to the game
        print("Player ", lastPlayer.name , " is placing stuff .. ", lastPlayerResult)
        lettersToReplace = ""
        changeOfScore = 0;
        for item in lastPlayerResult:
            if isinstance(item, list) and len(item) == 3:
                row, col, letter = item;
                if (lastPlayer.inBoard(row, col) and board[row][col] == ""):
                    board[row][col] = letter
                    lettersToReplace += letter
                    print("Placing ", letter, "at ", row,col)
                    changeOfScore+=1
            else:
                print("Error when reading result of ", lastPlayer.name, " result should be a list of list (e.g. [ [1,2,'a'] ]")
                print("Player instead returned: ", lastPlayerResult)
                quit()
        newBag = replaceLetters(lastPlayer, lettersToReplace, bag)
        lastPlayer.update(board, newBag, lastPlayer.myScore+1, nextPlayer.myScore, len(bag))
        nextPlayer.update(board, nextPlayer.bag, nextPlayer.myScore, lastPlayer.myScore+1, len(bag))
        return changeOfScore

    print("Wrong result from player.move; exit now");
    quit()
    return 0




if __name__ == "__main__":
    


    words = base.readDictionary('dic.txt') #words is represented as python-dictionray 

    board = base.createBoard("ABACUS") #this word should be from the dictionray
    board = base.createBoard(random.choice(list(words))) #random word from the dictionray

    bag = base.createInitialBag()

    player1bag = bag[0:7]   #letters for the player1
    player2bag = bag[7:14]  #letters for the player2
    bag = bag[14:] #remove first 14 letters


    p1 = Player("player1", words, board, player1bag, len(bag))
    p2 = Player("player2", words, board, player2bag, len(bag))
    p1.print()

    noChangeMoves = 0;
    while noChangeMoves < 3:

        result = p1.move()
        s1 = afterMove(p1, result, p2, board, bag)

        p1.print()

        result = p2.move();
        s2 = afterMove(p2, result, p1, board, bag)
        
        p2.print()

        if s1 + s2 == 0:
            noChangeMoves+=1
        else:
            noChangeMoves = 0


    print("Game finished after " , noChangeMoves , " moves without change of score ")




